set verify off
set feedback off
DECLARE 
   n NUMBER;
BEGIN
   n := DBMS_UTILITY.GET_TIME;
   FOR i IN 1 .. &1
   LOOP
      PLV.plsql_identifier := 'abc';
   END LOOP;
   DBMS_OUTPUT.PUT_LINE (DBMS_UTILITY.GET_TIME - n);

   n := DBMS_UTILITY.GET_TIME;
   FOR i IN 1 .. &1
   LOOP
      DECLARE
         c PLS_INTEGER := DBMS_SQL.OPEN_CURSOR;
         fdbk PLS_INTEGER;
      BEGIN
         DBMS_SQL.PARSE (c, 'BEGIN PLV.plsql_identifier := ''abc''; END;', DBMS_SQL.NATIVE);
         fdbk := DBMS_SQL.EXECUTE (c);
         DBMS_SQL.CLOSE_CURSOR (c);
      END;
   END LOOP;
   DBMS_OUTPUT.PUT_LINE (DBMS_UTILITY.GET_TIME - n);
END;
/
/*
10000 in 7.3
static 3
dynamic 736

1000 in 8.0
static 2
dynamic 798
*/

/*   
With PLVdyn

Oracle 8
SQL>  @dynplsql.tst 10000
static Elapsed: .03 seconds. Factored: 0 seconds.
PLVdyn dynamic Elapsed: 14.83 seconds. Factored: .00148 seconds.

Oracle 7.3
SQL>  @dynplsql.tst 10000
static           Elapsed:   .02 seconds. Factored: 0 seconds.
PLVdyn   dynamic Elapsed: 10.19 seconds. Factored: .00102 seconds.
DBMS_SQL dynamic Elapsed:  7.9 seconds.  Factored: .00079 seconds.*/
   
