CREATE OR REPLACE PACKAGE tabpkg 
IS
   TYPE names_tabtype IS TABLE OF VARCHAR2(100)
      INDEX BY BINARY_INTEGER;
END;
/
CREATE OR REPLACE PROCEDURE file_to_table 
   (loc_in IN VARCHAR2, file_in IN VARCHAR2, 
    table_in IN OUT tabpkg.names_tabtype)
IS
	/* Open file and get handle right in declaration */
	names_file UTL_FILE.FILE_TYPE := 
		UTL_FILE.FOPEN (loc_in, file_in, 'R');

	/* Counter used to store the Nth name. */
	line_counter INTEGER := 1;

BEGIN
	LOOP
		UTL_FILE.GET_LINE (names_file, table_in(line_counter));
		line_counter := line_counter + 1;
	END LOOP;
EXCEPTION
	WHEN NO_DATA_FOUND
	THEN
		UTL_FILE.FCLOSE (names_file);
END;
/