--------------------------------------------------------------------------------
-- Filename:	fixdefer.sql
-- Purpose:	Reports on deferred transaction with errors, and generates
--		call to dbms_defer_sys.execute_error to clear them.
-- Author:	Chas. Dye (cdye@dialog.com)
-- Date:	28-Jun-1996
--------------------------------------------------------------------------------

column DEFERRED_TRAN_DB	heading "Deferred|Tran|DB"	format a15
column DEFERRED_TRAN_ID	heading "Deffered|Tran|ID"	format a15
column DESTINATION	heading "Destination"		format a15
column ERROR_TIME	heading "Error Time"		format a22
column ERROR_NUMBER	heading "Error#"		format 999999
column FIX		heading "Run This to Clear"	format a80


SELECT	deferred_tran_id,
	deferred_tran_db,
	destination,
	to_char(error_time, 'DD-Mon-YYYY hh24:mi:ss') error_time,
	error_number
FROM	deferror
/

SELECT	'EXECUTE dbms_defer_sys.execute_error(' || chr(39) ||
	deferred_tran_id || chr(39) || ', '|| chr(39) ||
	deferred_tran_db || chr(39) || ',  - '|| chr(10) ||chr(39) ||
	destination || chr(39) || ' )'  fix
FROM	deferror
/
