REM **********************************************
REM * useful queries against the DBA_JOBS and 
REM * DBA_JOBS_RUNNING views
REM **********************************************

col job_definition clear
col job format 9999

col job_definition format a30 word_wrap
col username format a15

ALTER SESSION SET NLS_DATE_FORMAT='YYYY:MM:DD:HH24:MI:SS';

SELECT
        jr.job       job_id
       ,username     username
       ,jr.this_date start_date
       ,what         job_definition
  FROM 
        dba_jobs_running   jr
       ,dba_jobs           j
       ,v$session          s
 WHERE
        s.sid  = jr.sid
   AND  jr.job = j.job
ORDER BY jr.this_date;


col job_owner format a15
col job_definition format a30 word_wrap
SELECT
        job          
       ,log_user     job_owner
       ,failures
       ,broken
       ,what         job_definition
  FROM
        dba_jobs
 WHERE
        broken = 'Y' OR NVL(failures,0) > 0 ;


col job_definition format a30 word_wrap
col username format a15

ALTER SESSION SET NLS_DATE_FORMAT='YYYY:MM:DD:HH24:MI:SS';

SELECT 
        job
       ,next_date
       ,ROUND((next_date - SYSDATE)*24*60)  mins_to_exec
       ,what                         job_definition
  FROM
        dba_jobs
 WHERE
      broken != 'Y' 
  AND job NOT IN 
         (SELECT job 
            FROM dba_jobs_running)
 ORDER BY next_date ASC;
