rem ---------------------------------------------------------------------------
rem Filename:	jobs.sql
rem Purpose:	returns information about jobs in the job queue
rem Author:	cdye@krinfo.com
rem Date:	31-Jul-1996
rem ---------------------------------------------------------------------------

column JOB		heading "Job"		format 999
column LAST_DATE	heading "Last Date"	format a20
column NEXT_DATE	heading "Next Date"	format a20
column BROKEN		heading "B|r|o|k|e|n"	format a3
column INTERVAL		heading "Interval"	format a22
column FAILURES		heading "F|a|i|l"	format 999
column WHAT		heading "What"		format a75

SELECT	job,
	to_char(last_date, 'DD-Mon-YYYY HH24:mi:ss') last_date,
	to_char(next_date, 'DD-Mon-YYYY HH24:mi:ss') next_date,
	decode(broken, 'Y', 'Yes', 'No') broken,
	interval,
	failures
FROM	dba_jobs
/

SELECT	job,
	what
FROM	dba_jobs
/
