--------------------------------------------------------------------------------
-- Filename:	repsites.sql
-- Purpose:	Lists all replication sites.
-- Author:	Chas. Dye (cdye@dialog.com)
-- Date:	28-Jun-1996
--------------------------------------------------------------------------------

column GNAME		heading "Group"			format a8
column DBLINK		heading "DB-Link"		format a20
column MASTERDEF	heading "Master|Def|Site?"	format a6
column MASTER		heading "Master|Site?"		format a6
column PROP_UPDATES	heading "Prop|Updates"		format 999999
column MY_DBLINK	heading "My|DB-Link"		format a8


SELECT	gname,
	dblink,
	decode(masterdef, 'Y', 'Yes', 'No') masterdef,
	decode(master, 'Y', 'Yes', 'No') master,
	prop_updates,
	decode(my_dblink, 'Y', 'Yes', 'No') my_dblink
FROM	dba_repsites
ORDER BY gname ASC, masterdef DESC
/

